# DKRZ Python course materials

[![Gitlab-repo](https://img.shields.io/badge/gitlab-repo-green)](https://gitlab.dkrz.de/pythoncourse/material)
[![Pages](https://img.shields.io/badge/gitlab-pages-blue)](https://pythoncourse.gitlab-pages.dkrz.de/material)
[![Jupyterlite](https://img.shields.io/badge/exec-jupyterlite-red)](https://pythoncourse.gitlab-pages.dkrz.de/material/jupyterlite)

## Directories

| Section | Description |
|---|---|
| [notebooks](https://gitlab.dkrz.de/pythoncourse/material/-/tree/master/notebooks) | Basis content of the workshop |
| [data](https://gitlab.dkrz.de/pythoncourse/material/-/tree/master/data)      | data files for examples and exercises |
| [google-doc](https://docs.google.com/document/d/1VVX0DA7ieLN3rrBaEXdL6ADBfFPthZj7ARcEmzYBdsI/edit) | living doc for your questions and basic commands |

# Agenda

## Day 1 , 2022-10-04

| Starttime   | Endtime   | Title                                                                         | Content                                                                                                                                                                                                                      |   Duration [min] |
|:------------|:----------|:------------------------------------------------------------------------------|:-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|-----------------:|
| 09:00       | 09:10     | Welcome                                                                       | <ul><li>A short welcome to the participants and speakers.</li><li></li></u>                                                                                                                                                  |               10 |
| 09:10       | 09:30     | Hardware for Python: Difference between a supercomputer and your mobile phone | <ul><li> what is a node, cpu</li><li>  Historical development</li><li> Architecture</li><li></li></u>                                                                                                                        |               20 |
| 09:30       | 10:00     | What is Python – short intro                                                  | <ul><li> Difference between programming language and Python</li><li> Assembler, compiler, interpreter</li><li></li></u>                                                                                                      |               30 |
| 10:00       | 11:00     | Introduction to Linux system and setting up work environment                  | <ul><li> terminal</li><li> via WSL</li><li> command line and shell: (basics to transfer/run files and data in/out Mistral)</li><li> editor</li><li></li></u>                                                                 |               60 |
| 11:15       | 12:15     | Installation                                                                  | <ul><li> conda</li><li> python</li><li> modules/environments</li><li> envkernel conda name=kernelname user $condaenv</li><li> pythonrelated package management</li><li> testing installation and libraries</li><li></li></u> |               60 |
| 12:15       | 13:15     | Break                                                                         | nan                                                                                                                                                                                                                          |               60 |
| 13:15       | 13:30     | Installation - Questions/Answers                                              |                                                                                                                                                                                                                              |               15 |
| 13:30       | 14:30     | Jupyter notebooks, connecting to Mistral                                      | <ul><li> Jupyter lab</li><li> Jupyter hub</li><li> Jupyter lab</li><li></li></u>                                                                                                                                             |               60 |
| 14:30       | 15:00     | Syntax                                                                        | <ul><li> casesensitive</li><li> print</li><li> indentation and code blocks</li><li> line continuation</li><li> comments</li><li></li></u>                                                                                    |               30 |
| 15:00       | 15:15     | Data types                                                                    | <ul><li> boolean</li><li> integer</li><li> floatingpoint</li><li> complex</li><li> conversion between types</li><li> None</li><li></li></u>                                                                                  |               15 |
| 15:15       | 15:30     | Strings                                                                       | <ul><li> formatting</li><li> string functions</li><li></li></u>                                                                                                                                                              |               15 |
## Day 2 , 2022-10-05

| Starttime   | Endtime   | Title                            | Content                                                                                                                                                                |   Duration [min] |
|:------------|:----------|:---------------------------------|:-----------------------------------------------------------------------------------------------------------------------------------------------------------------------|-----------------:|
| 09:00       | 09:15     | Warmup about content of Day 1    |                                                                                                                                                                        |               15 |
| 09:15       | 10:45     | List, Tupels, sets, arrays, ...  | <ul><li> slices</li><li> dictionaries</li><li> intro to logic</li><li> copying objects, deep copy</li><li> mathematical operators and math functions</li><li></li></u> |               90 |
| 11:00       | 12:30     | Conditional statements, ...      | <ul><li> Iteration</li><li> Loops</li><li> List comprehensions</li><li></li></u>                                                                                       |               90 |
| 12:30       | 13:30     | Break                            | nan                                                                                                                                                                    |               60 |
| 13:30       | 15:45     | Functions, classes, scripts, ... | <ul><li> Functions </li><li> Classes and methods</li><li> Command line arguments for python scripts</li><li> File I/O</li><li></li></u>                                |              135 |
## Day 3 , 2022-10-06

| Starttime   | Endtime   | Title                                     | Content                                                 |   Duration [min] |
|:------------|:----------|:------------------------------------------|:--------------------------------------------------------|-----------------:|
| 09:00       | 09:15     | Warmup about content of Day 2             |                                                         |               15 |
| 09:15       | 10:45     | Numpy                                     |                                                         |               90 |
| 11:00       | 12:00     | Xarray - read/write netCDF and GRIB files |                                                         |               60 |
| 12:00       | 13:00     | Break                                     | nan                                                     |               60 |
| 13:00       | 13:30     | Exceptions/error handling                 | <ul><li> try, except</li><li> logging</li><li></li></u> |               30 |
| 13:30       | 14:45     | Data analysis                             | <ul><li> pythoncdo</li><li></li></u>                    |               75 |
| 14:45       | 15:45     | Python in action GLOBAGRIM                |                                                         |               60 |
## Day 4 , 2022-10-07

| Starttime   | Endtime   | Title                         | Content                                                                 |   Duration [min] |
|:------------|:----------|:------------------------------|:------------------------------------------------------------------------|-----------------:|
| 09:00       | 09:15     | Warmup about content of Day 3 |                                                                         |               15 |
| 09:15       | 11:15     | Visualization                 | <ul><li> matplotlib</li><li> cartopy</li><li> seaborn</li><li></li></u> |              120 |
| 11:30       | 12:30     | Interesting packages          | <ul><li>Overview of some recommendable packages</li><li></li></u>       |               60 |
| 12:30       | 13:45     | Break                         | nan                                                                     |               75 |
| 13:45       | 15:45     | Exercise                      |                                                                         |              120 |
| 15:45       | 16:00     | Feedback                      |                                                                         |               15 |